=== debian/changelog ===
rpma (1.3.0-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:03:27 +1100

rpma (1.3.0-2build1) noble; urgency=medium

  * No-change rebuild against librdmacm1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:13:15 +0000

rpma (1.3.0-2) unstable; urgency=medium

  * Make the build reproducible and multiarch-coinstallable.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 09 Jun 2023 14:33:38 +0200

rpma (1.3.0-1) experimental; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 29 May 2023 11:19:10 +0200
